-- noqa: disable=all
-- This sql was autogenerated as a reference example using the library
-- CLI. Its format is tied to the specific database it was run against,
-- and it may not be correct for all databases. Use the CLI's build 
-- option to derive the best SQL for your dataset.

-- ###########################################################

CREATE TABLE catalog__count_icd10_diagnoses AS (
    WITH
    filtered_table AS (
        SELECT
            s.subject_ref,
            --noqa: disable=RF03, AL02
            s."code"
            --noqa: enable=RF03, AL02
        FROM core__condition AS s
    ),
    
    null_replacement AS (
        SELECT
            subject_ref,
            coalesce(
                cast(code AS varchar),
                'cumulus__none'
            ) AS code
        FROM filtered_table
    ),

    powerset AS (
        SELECT
            count(DISTINCT subject_ref) AS cnt_subject_ref,
            "code",
            concat_ws(
                '-',
                COALESCE("code",'')
            ) AS id
        FROM null_replacement
        GROUP BY
            cube(
            "code"
            )
    )

    SELECT
        p.cnt_subject_ref AS cnt,
        p."code",
        j."chapter_code",
        j."chapter_str",
        j."block_code",
        j."block_str",
        j."category_code",
        j."category_str",
        j."subcategory_1_code",
        j."subcategory_1_str",
        j."subcategory_2_code",
        j."subcategory_2_str",
        j."subcategory_3_code",
        j."subcategory_3_str",
        j."extension_code",
        j."extension_str"
    FROM powerset AS p
        JOIN "umls"."icd10_hierarchy" j ON p.code = j.leaf_code
    WHERE
        block_code not in('A50-A64','A70-A74','B20-B20')
        AND chapter_code not in('F01-F99','Z00-Z99')
        AND cnt_subject_ref >= 10
        
);
